<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="../../static/css/matrices/detInvTras.css">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css"
        integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"
        integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj"
        crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-ho+j7jyWK8fNQe+A12Hb8AhRq26LrZ/JpcUGGOn+Y7RsweNrtN/tE3MoK7ZeZDyx"
        crossorigin="anonymous"></script>
    <link rel="shortcut icon" href="{{ url_for('static', filename='./images/pi.png') }}">
    <title>Matrices</title>
</head>

<body>

    <!-- ESTO ES EL NAVBAR -->
    <nav class="navbar navbar-expand-lg  fixed-top  navbar-dark" style="background-color: #339dee;">
        <a class="navbar-brand" href="./">
            <img src="../static/images/math.png" width="45" height="45" alt="" loading="lazy"
                style="margin-left: 10px;">
        </a>
        <a class="navbar-brand" href="./" style="margin-right: 25px;">NumeriCalc</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNavDropdown"
            aria-controls="navbarNavDropdown" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarNavDropdown">
            <ul class="navbar-nav">
                <li class="nav-item active">
                    <a class="nav-link" href="./">Home <span class="sr-only">(current)</span></a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="./derivadas">Derivada</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="./graficadora">Graficadora</a>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" role="button"
                        data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Conversiones
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                        <a class="dropdown-item" href="./bases">Entre Bases</a>
                        <a class="dropdown-item" href="./standardieee754">Estándar IEE 754</a>
                    </div>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" role="button"
                        data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Raíces
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                        <a class="dropdown-item" href="./biseccion">Bisección</a>
                        <a class="dropdown-item" href="./reglafalsa">Regla Falsa</a>
                        <a class="dropdown-item" href="./newtonraphson">Newton-Raphson</a>
                        <a class="dropdown-item" href="./secante">Secante</a>
                        <a class="dropdown-item" href="/raicespolinomios">Raíces de Polinomios</a>
                    </div>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" role="button"
                        data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Integrales
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                        <a class="dropdown-item" href="./rectangulos">Rectángulos</a>
                        <a class="dropdown-item" href="./trapecios">Trapecios</a>
                        <a class="dropdown-item" href="./simpson13">Simpson 1/3</a>
                        <a class="dropdown-item" href="./simpson38">Simpson 3/8</a>
                        <a class="dropdown-item" href="./montecarlo">Montecarlo</a>
                    </div>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbarDropdownMenuLink" role="button"
                        data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Matrices
                    </a>
                    <div class="dropdown-menu" aria-labelledby="navbarDropdownMenuLink">
                        <a class="dropdown-item" href="./Msuma">Suma</a>
                        <a class="dropdown-item" href="./Mresta">Resta</a>
                        <a class="dropdown-item" href="./detInvTras">Determinante, Traspuesta, Inversa</a>
                        <a class="dropdown-item" href="./matrizMultiplicacion">Multiplicación</a>
                        <a class="dropdown-item" href="./gaussJordan">Gauss Jordan</a>
                    </div>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="./ajusteCurvas">Ajuste de Crurvas</a>
                </li>
                <li class="nav-item" style="margin-left: 720px;">
                    <a class="nav-link" href="./nosotros">Sobre Nosotros</a>
                </li>
            </ul>
        </div>
    </nav>


    <!-- ESTO ES EL CONTENIDO -->
    <div class="page">


        <div class="textContent">
            <h3 class="text-left" style="margin-top:20px; color:#1689e0;">
                Determinante, inversa y transpuesta de una matriz.
            </h3>

            <p class="text-left" style="margin-right: 100px;">
                La traspuesta de una matriz es el resultado de tomar la matriz original y reorganizarla cambiando sus
                filas por las columnas y las columnas por filas.<br>
                El determinante de una matriz es el resultado resultado de restar la multiplicación de los elementos de
                la diagonal principal con la multiplicación de los elementos de la diagonal secundaria.
                La matriz inversa de es la única matriz que al multiplicarla por ella se obtiene la matriz identidad del
                orden correspondiente.
            </p>
        </div>


        <!-- AQUÍ VA EL CONTENIDO -->
        <div class="content">
            <form action="/detInvTras" method="POST">

                <div class="dimensionContent" style="width: 100%;">
                    <div class="dimensionesForm">
                        <h4 class="text-left" style="margin-top:20px; color:#1689e0;">
                            Dimensiones de la Matriz
                        </h4>

                        <div class="form-group" style="width: 180px;">
                            <label>Filas</label>
                            <input class="form-control" type="number" value="5" id="FilA" name="FilA">
                        </div>
                        <div class="form-group" style="width: 180px; margin-left: 25px;">
                            <label> Columnas</label>
                            <input class="form-control" type="number" value="5" id="ColA" name="ColA">
                        </div>
                    </div>
                </div>

                <div class="matrixContent">
                    <h4 class="text-center" style="width:100%; margin-top:20px; color:#1689e0;">
                        Matriz
                    </h4>
                    <div id="matrizA">
                    </div>
                    <div class="vectores" style="display: none;">
                        <input id="vectorA" name="vectorA">
                    </div>
                </div>

                <div class="btnContent" style="margin-top: 20px;">
                    <button class="btn btn-primary" style="width: 120px; margin-right: 20px;" type="submit"
                        name="Calcular">Resolver</button>
                    <button class="btn btn-primary" style="width: 120px;" type="submit" name="Borrar">Borrar</button>
                </div>

            </form>


            <div class="contentResultados" style="margin-top: 20px;">

                <h4 class="text-center" style="width:100%; margin-top:20px; color:#1689e0;">
                    Resultado
                </h4>
                


                <div class="form-group blue-border shadow-textarea" style="margin: 10px; width: 200px;">
                    <h6 class="text-center" for="exampleFormControlTextarea4">
                        Determinante
                    </h6>
                    <textarea class="form-control" style="border-color: dodgerblue; resize: horizontal;" name="inv"
                        id="exampleFormControlTextarea4" rows="3" cols="10">{{det}}</textarea>
                </div>



            </div>

            <div class="contentResultados">
                <div class="form-group blue-border shadow-textarea" style="margin: 10px;">
                    <h6 class="text-center" for="exampleFormControlTextarea4">
                        Matriz Original
                    </h6>
                    <textarea class="form-control" style="border-color: dodgerblue; width:300px; resize: both;" name="inv"
                        id="exampleFormControlTextarea4" rows="8" cols="20">{{matriz}}</textarea>
                </div>
                <div class="form-group blue-border shadow-textarea" style="margin: 10px;">
                    <h6 class="text-center" for="exampleFormControlTextarea4">
                        Traspuesta
                    </h6>
                    <textarea class="form-control" style="border-color: dodgerblue; width:300px; resize: both;" name="inv"
                        id="exampleFormControlTextarea4" rows="8" cols="20">{{trans}}</textarea>
                </div>
                <div class="form-group blue-border shadow-textarea" style="margin: 10px">
                    <h6 class="text-center" for="exampleFormControlTextarea4">
                        Inversa
                    </h6>
                    <textarea class="form-control" style="border-color: dodgerblue;  width:300px; resize: both" name="inv"
                        id="exampleFormControlTextarea4" rows="8" cols="20">{{inv}}</textarea>
                </div>
            </div>
        </div>
    </div>



    <!-- ESTO ES EL FOOTER -->
    <footer id="sticky-footer" class="py-4 bg-dark text-white-50">
        <div class="container text-center">
            <small>Copyright &copy; NumeriCalc</small>
        </div>
    </footer>




    <script>
        const filaA = document.getElementById("FilA");
        const columnaA = document.getElementById("ColA");
        let filasA = filaA.value;
        let columnasA = columnaA.value;
        actualizarhtml();

        filaA.addEventListener("change", () => {
            // Detecta un cambio en las filas
            filasA = parseInt(filaA.value);
            if (filasA > 7) {
                alert("el máximo de filas es 7");
                filaA.value = 7;
            } else {
                if (filasA < 1) {
                    alert("el mínimo de filas es 1");
                    filaA.value = 1;
                } else {
                    actualizarhtml();
                }
            }
        });
        columnaA.addEventListener("change", () => {
            // Detecta un cambio en las columnas
            columnasA = parseInt(columnaA.value);
            if (columnasA > 7) {
                alert("el máximo de columnas es 7");
                columnaA.value = 7;
            } else {
                if (columnasA < 1) {
                    alert("el mínimo de columnas es 2");
                    columnaA.value = 1;
                } else {
                    actualizarhtml();
                }
            }
        });

        function updateinputstate() {
            for (let fil = 1; fil <= filasA; fil++) {
                for (let cols = 1; cols <= columnasA; cols++) {
                    document.getElementById(`Af${fil}c${cols}`).addEventListener("change", () => {
                        obtenervectores();
                    });
                }
            }
            obtenervectores();
        }

        function actualizarhtml() {
            document.getElementById("matrizA").innerHTML = "";
            let ingresarA = "<div class='row'>";
            ingresarA += `<div class="col"></div>`;
            for (let i = 1; i <= columnasA; i++) {
                ingresarA += `<div class="col">C${i}</div>`;
            }
            ingresarA += "</div>"
            for (let i = 1; i <= filasA; i++) {
                // ingresa una fila
                ingresarA += `<div class="row"><p class="col">F${i}</p>`;
                for (let j = 1; j <= columnasA; j++) {
                    //ingresa cada columna a la fila
                    ingresarA += `<input class="col" id="Af${i}c${j}" value="0">`;
                }
                if (this.ecuaciones == true) {
                    //ingresa cada columna de igualdad a la fila de ecuaciones
                    ingresarA += `<input class="col" id="E${i}" value="0">`;
                }
                ingresarA += "</div>"
            }
            document.getElementById("matrizA").innerHTML += ingresarA;
            updateinputstate();
            obtenervectores();
        }
        function obtenervectores() {
            let vectorA = "";
            for (let i = 1; i <= filasA; i++) {
                vectorA += "[";
                for (let j = 1; j <= columnasA; j++) {
                    vectorA += document.getElementById(`Af${i}c${j}`).value;
                    if (j < columnasA) {
                        vectorA += ",";
                    } else {
                        vectorA += "]";
                    }
                }
                if (i < filasA) {
                    vectorA += ",";
                }
            }
            document.getElementById("vectorA").value = vectorA;
        }
    </script>
</body>

</html>